/* $Id: Sinhsp.java,v 1.9 2010/09/25 07:11:42 mit Exp $ */
/* Sin25.java to Sinhsp.java */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class Sinhsp extends Applet implements AdjustmentListener
{
    private Scrollbar scrS;
    private Scrollbar sctP;

    static int L = 40;            // Ĺ
    static int P = 20;            // ܿ
    static int F = 64;
    static double T = 2d*Math.PI/F;

    int W;
    int H;
    int LeftSide;
    int DownSide;
    int Spoint;
    int Part;
    DecimalFormat df1;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

        Panel p = new Panel();
        p.setLayout(new GridLayout(2,2,0,0));

        scrS = new Scrollbar(Scrollbar.HORIZONTAL,L/2,1,1,L);
        p.add(scrS);
	scrS.addAdjustmentListener(this);

        p.add(new Label(" : Striking Point"));

	sctP = new Scrollbar(Scrollbar.HORIZONTAL,P,1,1,P+1);
        p.add(sctP);
	sctP.addAdjustmentListener(this);

        p.add(new Label(" : Partial"));

        add(p, "South");
    }
    public void start() {
	W = getSize().width;
        H = getSize().height;
	LeftSide = (int)(W/(double)P);
	DownSide = (int)(H/4.0*3);
    }
    public String dform(double n){
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
	Spoint = scrS.getValue(); // Ǹ
	Part = sctP.getValue();

	g.setColor(Color.black);
        g.fillRect(0, 0, W, H);

	g.setColor(Color.blue);
        g.drawLine(0, DownSide, W, DownSide);
	g.drawLine(LeftSide, 0, LeftSide, H);
	
	g.setColor(Color.red);
	g.drawString("Striking Point: 1/"+
		     dform(1.0/(Spoint/(double)L)), 20, 20);
	g.drawString("Partial: "+Part, (int)(W*2.0/3), 20);

	disp_partial(g);
	disp_wave(g);
    }
    public void disp_partial(Graphics g) {
	double y1, xd = (W-LeftSide)/(double)P;
	int wide = (int)(xd/5);
	int dh = 5*H;
	int x1;

	for (int i = 1; i <= Part; i++) {
	    x1 = (int)(LeftSide+i*xd);
	    y1 = Math.abs(yys(i)*dh); // z

	    g.setColor(Color.green);
	    g.fillRect(x1-1, (int)(DownSide-y1), wide, (int)y1);

	    g.setColor(Color.blue);
	    g.drawLine(x1, DownSide, x1, DownSide+8);

	    if (i % 5 == 0) {
		g.drawLine(x1, DownSide, x1, DownSide+16);

		g.setColor(Color.magenta);
		g.drawString(""+i, x1, DownSide+26);
	    }
	}
    }
    public void disp_wave(Graphics g) {
	double fw = (W-LeftSide)/(double)F;
	int ch = (int)(H*2/5d);
	int dg = 3*H;

	g.setColor(Color.gray);
	g.drawLine(0, ch, W, ch);

	double[] sum = calc_wave();

	double x0, y0, x1 = 0, y1 = 0;
	g.setColor(Color.white);
	for (int i = 0; i <= F; i++) {
	    x0 = LeftSide+fw*i;
	    y0 = ch-dg*sum[i];
	    if (i == 0) {
		x1 = x0;
		y1 = y0;
		continue;
	    }
	    g.drawLine((int)x1, (int)y1, (int)x0, (int)y0);
	    x1 = x0;
	    y1 = y0;
	}
    }
    public double[] calc_wave() {
	double[] sum = new double[F+1];

	for (int j = 0; j < F; j++) {
	    for (int i = 1; i <= Part; i++)
		sum[j] += Math.sin(T * j * i)*Math.abs(yys(i)); // z
	}

	return sum;
    }
    public double yys(int mm) { // z
	double mp = mm * Math.PI;
	return Math.sin(mp*Spoint/L)/Math.pow(mp, 2);
    }
}